freeslot("SKINCOLOR_VANDALISM", "SPR_CTAU", "SPR2_CTNJ", "SFX_SGRC", "SFX_INDD", "SFX_JHCN", "SFX_MCTW", "SFX_MCTR", "MT_DINNER", "S_CATTINO_AURA", "SFX_DIN2", "SFX_MTLFR", "SPR2_CTNS", "S_PLAY_CATTINO_NOSCOPE", "S_PLAY_CATTINO_DINNERSLAM")

states[S_CATTINO_AURA] = {
        sprite = SPR_CTAU,
        frame = A|FF_FULLBRIGHT,
        tics = 1,
        var1 = 3,
        var2 = 2,
        nextstate = S_NULL
}

states[S_PLAY_CATTINO_NOSCOPE] = {
        sprite = SPR_PLAY,
        frame = SPR2_CTNS,
        tics = 1,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_CATTINO_NOSCOPE
}

states[S_PLAY_CATTINO_DINNERSLAM] = {
        sprite = SPR_PLAY,
        frame = SPR2_CTNJ,
        tics = 1,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_CATTINO_DINNERSLAM
}

mobjinfo[MT_DINNER].name = "Dinner"

rawset(_G, "P_GravAndScale", function(actor)
	return P_MobjFlip(actor)*actor.scale
end)


local function DinnerBreakafloor(mo, sec)
	for fof in sec.ffloors()
		if not (fof.flags & FF_EXISTS) 
			continue 
		end
		if not (fof.flags & FF_BUSTUP) 
			continue 
		end
		if mo.z + mo.momz + mo.height < fof.bottomheight 
			continue 
		end
		if mo.z + mo.momz > fof.topheight 
			continue 
		end
		EV_CrumbleChain(fof)
	end
end

local function DinnerLineShatter(s, dist)
		local line = {}
		searchBlockmap("lines", function(m, linedef)
		local x,y = P_ClosestPointOnLine(m.x, m.y, linedef)
		if (R_PointToDist2(m.x, m.y, x, y) < dist)
			table.insert(line, linedef)
		else
			return
		end
	end, s, s.x-dist, s.x+dist, s.y-dist, s.y+dist)
	for i = 1, #line
		if line[i].valid
			local backfront = {line[i].frontsector, line[i].backsector}
			for d = 1, #backfront
				for fof in backfront[d].ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and ((abs(s.z-fof.topheight) <= dist) or (abs(s.z-fof.bottomheight) <= dist))
					and ((s.type == MT_DINNER) or not (fof.flags & FF_STRONGBUST))
						EV_CrumbleChain(nil, fof)
            		end
        		end
			end
		end
	end
end

//thanks example character jingles
addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local character = skins[consoleplayer.skin].name
		if character == "cattino"
			if newname == "_1up"
				return "CT1UP"
			elseif newname == "_clear"
				return "CTCLEAR"
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin == "cattino"
		if player.target
		and (player.cmd.buttons & BT_JUMP)
		and not P_IsObjectInGoop(player.mo)
		and not (player.pflags & PF_THOKKED)
		and not (player.pflags & PF_USEDOWN)
			S_StartSound(player.mo, sfx_slam)
			player.pflags = $|PF_THOKKED 
			player.groundpounding = true
			end
		if not player.target
		and not P_IsObjectInGoop(player.mo)
		and not (player.pflags & PF_THOKKED)
		and not (player.pflags & PF_USEDOWN)
			S_StartSound(player.mo, sfx_jhcn)
			player.pflags = $|PF_THOKKED 
			P_Thrust(player.mo, player.mo.angle, 10*FRACUNIT)
			P_SetObjectMomZ(player.mo, 20*FRACUNIT)
			player.groundpounding = true
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate
		local gpspeed = 11*FRACUNIT
		if player.mo.eflags & MFE_UNDERWATER
			gpspeed = $ - 4*FRACUNIT
		end
		if player.mo.skin == "cattino"
		and not P_IsObjectInGoop(player.mo)
		and player.groundpounding == true
		and player.mo.eflags & MFE_JUSTHITFLOOR
			player.groundpounding = false
			player.hasdinnerslammed = false
			P_SetObjectMomZ(player.mo, gpspeed, true)
			P_FlashPal(player, 2, 8)
			P_NukeEnemies(player.mo, player.mo, 125*FRACUNIT)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~PF_THOKKED
			player.mo.spriteyscale = FRACUNIT
			S_StartSound(player.mo, sfx_s3k77)
			end
		if player.mo.skin == "cattino"
		and player.groundpounding
		and player.cmd.buttons & BT_USE
		and not player.hasdinnerslammed
			player.mo.state = S_PLAY_CATTINO_DINNERSLAM
			P_SetObjectMomZ(player.mo, -20*FRACUNIT)
			P_SpawnPlayerMissile(player.mo, MT_DINNER)
			S_StartSound(player.mo, sfx_din2)
			player.hasdinnerslammed = true
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin == "cattino"
		if player.mo.state == S_PLAY_WALK
		and not S_SoundPlaying(player.mo, sfx_mctw)
			S_StartSound(player.mo, sfx_mctw)
			S_StopSoundByID(player.mo, sfx_mctr)
			end
		if not player.mo.state == S_PLAY_WALK
			S_StopSoundByID(player.mo, sfx_mctw)
			end
		if player.mo.state == S_PLAY_RUN
		and not S_SoundPlaying(player.mo, sfx_mctr)
			S_StartSound(player.mo, sfx_mctr)
			S_StopSoundByID(player.mo, sfx_mctw)
			end
		if not player.mo.state == S_PLAY_RUN
			S_StopSoundByID(player.mo, sfx_mctr)
			end
		if player.speed <=1
			S_StopSoundByID(player.mo, sfx_mctr)
			S_StopSoundByID(player.mo, sfx_mctw)
			end
		if not P_IsObjectOnGround(player.mo)
			S_StopSoundByID(player.mo, sfx_mctr)
			S_StopSoundByID(player.mo, sfx_mctw)
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "cattino")
		and not (player.exiting)
			if player.powers[pw_super]
				local cattinoaura = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z-FixedMul(player.mo.height/8, P_GravAndScale(player.mo)), MT_OVERLAY)
				cattinoaura.target = player.mo
				cattinoaura.skin = "cattino"
				cattinoaura.state = S_CATTINO_AURA
				cattinoaura.fuse = 1
				if player.skincolor == SKINCOLOR_WHITE
					cattinoaura.color = SKINCOLOR_SKY
				else
					cattinoaura.color = player.skincolor
				end
				cattinoaura.colorized = true
				cattinoaura.blendmode = AST_ADD
				cattinoaura.rollangle = player.mo.rollangle
				cattinoaura.angle = player.drawangle
				cattinoaura.scale = P_RandomRange(cattinoaura.target.scale+FixedMul(FRACUNIT/4, player.mo.scale), cattinoaura.target.scale+2*FixedMul(FRACUNIT/5, player.mo.scale))
				if player.mo.eflags & MFE_VERTICALFLIP
					cattinoaura.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(cattinoaura, cattinoaura.x, cattinoaura.y, cattinoaura.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
				if (leveltime % 4 == 0)
					cattinoaura.frame = B|FF_FULLBRIGHT
				elseif (leveltime % 5 == 0)
					cattinoaura.frame = C|FF_FULLBRIGHT
				elseif (leveltime % 6 == 0)
					cattinoaura.frame = D|FF_FULLBRIGHT
				elseif (leveltime % 7 == 0)
					cattinoaura.frame = D|FF_FULLBRIGHT
				elseif (leveltime % 10 == 0)
					cattinoaura.frame = C|FF_FULLBRIGHT
				elseif (leveltime % 12 == 0)
					cattinoaura.frame = A|FF_FULLBRIGHT
				end
			end
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.type == MT_DINNER
			DinnerBreakafloor(mo,mo.subsector.sector)
			DinnerLineShatter(mo, 64*FRACUNIT)
			local dinnerghost = P_SpawnGhostMobj(mo)
			dinnerghost.blendmode = AST_ADD
			dinnerghost.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
			dinnerghost.colorized = true
			for i = 0,9
				dinnerghost.fuse = 6
				dinnerghost.scale = (FRACUNIT * 8/10) - (i * FRACUNIT/320)
				dinnerghost.destscale = 0
			end
		end
	end
end, MT_DINNER)

addHook("PlayerThink", function(player)
	if player.mo.skin == "cattino"
	and not (player.pflags & PF_THOKKED)
	and not (player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_DEAD)
	and (player.cmd.buttons & BT_USE)
	and not player.groundpounding
		if not P_IsObjectOnGround(player.mo)
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
		else
			P_SetObjectMomZ(player.mo, 2*FRACUNIT, false)
		end
		P_SpawnPlayerMissile(player.mo, MT_DINNER)
		S_StartSound(player.mo, sfx_din2)
		player.mo.state = S_PLAY_CATTINO_NOSCOPE
		player.pflags = $1|PF_THOKKED
	end
end)

addHook("PostThinkFrame", function(player)
	for player in players.iterate
	if (player.mo.skin == "cattino")
		if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
		and (player.cmd.buttons & (BT_TOSSFLAG|BT_CUSTOM1)) == BT_TOSSFLAG|BT_CUSTOM1
			player.mo.state = S_CTPOSE
			S_StartSound(player.mo, sfx_indd)
			end
		end
	if (player.mo.state == S_CTPOSE) 
	 player.pflags = $|PF_FULLSTASIS
	 end
	if (player.mo.state == S_CTPOSE) 
	 and (player.cmd.buttons & BT_JUMP)
	 player.mo.state = S_PLAY_STND
	 player.pflags = $ & ~PF_FULLSTASIS
	    end
    end
end)